
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Models &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <script async="async" src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
    <script>window.MathJax = {"tex": {"inlineMath": [["$", "$"], ["\\(", "\\)"]], "processEscapes": true}, "options": {"ignoreHtmlClass": "tex2jax_ignore|mathjax_ignore|document", "processHtmlClass": "tex2jax_process|mathjax_process|math|output_area"}}</script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Base Classes" href="LSTM_Base.html" />
    <link rel="prev" title="Treatment functions" href="Cleaning.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 current active nav-item">
 <a class="current reference internal nav-link" href="#">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    <ul class="nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="LSTM_Base.html">
   Base Classes
  </a>
 </li>
</ul>
<ul class="nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="LSTM.html">
   Regular LSTMs
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="LSTMwithNorm.html">
   LSTMs with normalization
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="LSTMchem.html">
   LSTMs with chemistry
  </a>
 </li>
</ul>

  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                
<div class="tocsection onthispage pt-5 pb-3">
    <i class="fas fa-list"></i> On this page
</div>

<nav id="bd-toc-nav">
    <ul class="visible nav section-nav flex-column">
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#architecture">
   Architecture
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#base-classes">
   Base Classes
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#variants">
   Variants
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#developing-new-models">
   Developing New Models
  </a>
 </li>
</ul>

</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <div class="section" id="models">
<h1>Models<a class="headerlink" href="#models" title="Permalink to this headline">¶</a></h1>
<p>This Neural net is based on the one proposed by You et al.’s snapshot approach
(see note for full reference). The one proposed by the authors corresponds to
version 1, but many others were developed (a total of 5). Versions 1-3 are
included in the corresponding <code class="docutils literal notranslate"><span class="pre">LSTM_v1</span></code> classes, whilst versions 4-5 are
included in the <code class="docutils literal notranslate"><span class="pre">LSTM_v4</span></code> classes. Versions 4 and 5 are analogous to versions
1 and 2, but take the ambient temperature as an extra input directly at the
last linear layer. Check their documentation to learn more about the
different versions and how to call them.</p>
<p>With the data in hand, a dataset must be created through the corresponding
Dataset class (<code class="docutils literal notranslate"><span class="pre">Torch_Dataset_LSTM</span></code>), which will adapt and normalize the
inputs and outputs according to the desired model <code class="docutils literal notranslate"><span class="pre">version</span></code>. To read more
about it check <a class="reference internal" href="LSTM.html#normal-lstm-dataset"><span class="std std-ref">Dataset Class</span></a>. To <em>train</em> a
model please check <a class="reference internal" href="Training.html"><span class="doc">Training and Simulation</span></a>.</p>
<p>All of the models have the same underlying architecture, presented next.</p>
<div class="section" id="architecture">
<h2>Architecture<a class="headerlink" href="#architecture" title="Permalink to this headline">¶</a></h2>
<p>The strucutre is composed of three layers:</p>
<ol class="arabic">
<li><p>An LSTM layer that takes in a sequence of <span class="math notranslate nohighlight">\(x_i\)</span> s as input.</p>
<blockquote>
<div><p>Together, they (the <span class="math notranslate nohighlight">\(x_i\)</span> s) represent one charge cycle.
Each <span class="math notranslate nohighlight">\(x_i\)</span> is composed of a number <span class="math notranslate nohighlight">\({\Delta}\)</span> of sequential
<span class="math notranslate nohighlight">\((I, V)\)</span> or <span class="math notranslate nohighlight">\((I, V, T)\)</span> points, spread out in a 1D vector.
The actual shape of the inputs is thus: <code class="docutils literal notranslate"><span class="pre">[batch_size,</span> <span class="pre">sequence_length,</span>
<span class="pre">number_of_features]</span></code>, and the outputs have shape <code class="docutils literal notranslate"><span class="pre">[batch_size,</span>
<span class="pre">sequence_length,</span> <span class="pre">hidden_dimension*number_of_LSTMs]</span></code>.</p>
<p>The number of features depends on the model’s version (check the classes
cited previously for more information) If the LSTM is a bidirectional type,
then the <code class="docutils literal notranslate"><span class="pre">number_of_LSTMs</span></code> is equal to two. Otherwise, one.</p>
</div></blockquote>
</li>
<li><p>A Pooling layer that treats the LSTM outputs in some way.</p>
<blockquote>
<div><p>Three possibilities are proposed by the authors for the pooling layer, and
are implemented here:</p>
<ol class="arabic simple">
<li><p>taking only the last output</p></li>
<li><p>taking the mean of the outputs</p></li>
<li><p>using a BiLSTM and taking the mean of the product of the results</p></li>
</ol>
<p>We recommed the latter.</p>
</div></blockquote>
</li>
<li><p>A linear layer that gives the final output.</p>
<blockquote>
<div><p>It’s just one linear layer so the number of inputs and outputs is set by
the LSTM’s number of hidden dimensions and its version.</p>
</div></blockquote>
</li>
</ol>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Full reference: G. You, S. Park and D. Oh, “Diagnosis of Electric
Vehicle Batteries Using Recurrent Neural Networks,” in IEEE Transactions
on Industrial Electronics, vol. 64, no. 6, pp. 4885-4893, June 2017,
doi: 10.1109/TIE.2017.2674593.</p>
</div>
</div>
<div class="section" id="base-classes">
<h2>Base Classes<a class="headerlink" href="#base-classes" title="Permalink to this headline">¶</a></h2>
<p>All model and dataset classes are child classes of the base classes defined in
<a class="reference internal" href="LSTM_Base.html#module-LSTM_Base" title="LSTM_Base"><code class="xref py py-mod docutils literal notranslate"><span class="pre">LSTM_Base</span></code></a>. This module was created just to define methods that
are common to all classes so that they don’t have to be repetitively defined
each time.</p>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="LSTM_Base.html">Base Classes</a></li>
</ul>
</div>
</div>
<div class="section" id="variants">
<span id="lstm-variants"></span><h2>Variants<a class="headerlink" href="#variants" title="Permalink to this headline">¶</a></h2>
<p>More than just the regular (<code class="docutils literal notranslate"><span class="pre">'normal'</span></code>) variant, we have LSTMs that do the
normalisation of the inputs and outputs (LSTMs with normalization) and LSTMs
that also take in the battery chemistry as an input. The class names are the
same so that their use is analogous. More in depth explanations about their
specificities are presented in their pages:</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Recommended way of importing (in order to avoid confusion with the class
names):</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">LSTM_with_norm</span> <span class="k">as</span> <span class="nn">wn</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">LSTM_chemistry</span> <span class="k">as</span> <span class="nn">chem</span>
</pre></div>
</div>
</div>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="LSTM.html">Regular LSTMs</a></li>
<li class="toctree-l1"><a class="reference internal" href="LSTMwithNorm.html">LSTMs with normalization</a></li>
<li class="toctree-l1"><a class="reference internal" href="LSTMchem.html">LSTMs with chemistry</a></li>
</ul>
</div>
</div>
<div class="section" id="developing-new-models">
<span id="new-models"></span><h2>Developing New Models<a class="headerlink" href="#developing-new-models" title="Permalink to this headline">¶</a></h2>
<p>If you’re thinking of developing new models and want to integrate them to the
existing framework developed here, go ahead! In order to assure they’ll work
with the other codes, check the <a class="reference internal" href="LSTM_Base.html"><span class="doc">Base Classes’s</span></a> source
code for the methods defined there, since they’ll be called by other functions.
You can redefine them in your own classes if you think it’s better.</p>
</div>
</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                
    <a class='left-prev' id="prev-link" href="Cleaning.html" title="previous page">Treatment functions</a>
    <a class='right-next' id="next-link" href="LSTM_Base.html" title="next page">Base Classes</a>

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>